﻿Public Class Form1
    Dim dt As New DataTable()
    Dim _StartSearch As Boolean

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        dt.Columns.Add("CustomerID", GetType(Integer))
        dt.Columns.Add("ContactName", GetType(String))
        dt.Columns.Add("Designation", GetType(String))
        dt.Columns.Add("Country", GetType(String))

        'Sample Data
        dt.Rows.Add(1, "Maria Anders", "Sales Representative", "Spain")
        dt.Rows.Add(2, "Ana Trujillo", "Sales Associate", "Mexico")
        dt.Rows.Add(3, "Antonio Moreno", "Owner", "Ireland")
        dt.Rows.Add(4, "Thomas Hardy", "Sales Representative", "UK")
        dt.Rows.Add(5, "Patricio Simpson", "Marketing Manager", "Germany")
        dt.Rows.Add(6, "Paolo Accorti", "Sales Representative", "Spain")
        dt.Rows.Add(7, "Martine Rancé", "Owner", "Mexico")
        dt.Rows.Add(8, "Elizabeth Brown", "Marketing Manager", "UK")
        dt.Rows.Add(9, "Jaime Yorres", "Order Administrator", "Austria")
        dt.Rows.Add(10, "Yvonne Moncada", "Marketing Manager", "Mexico")
        dt.Rows.Add(11, "Helen Bennett", "Owner/Marketing", "Ireland")
        dt.Rows.Add(12, "Sergio Gutiérrezy", "Order Administrator", "Brazil")

        'Assigning Sample DataSource
        C1FlexGrid1.DataSource = dt
        C1FlexGrid1.AutoSizeCols()
        'To enable control to fire OwnerDrawCell Event
        C1FlexGrid1.DrawMode = C1.Win.C1FlexGrid.DrawModeEnum.OwnerDraw
    End Sub

    Private Sub tbSearchBox_TextChanged(sender As Object, e As EventArgs) Handles tbSearchBox.TextChanged
        'If TextBox contains No Text
        If tbSearchBox.Text = String.Empty Then
            _StartSearch = False

            Dim rg As New C1.Win.C1FlexGrid.CellRange()
            rg.c1 = 1
            rg.c2 = C1FlexGrid1.Cols.Count - 1
            rg.r1 = 1
            rg.r2 = C1FlexGrid1.Rows.Count - 1
            'Select all cells to redraw their content with default color
            C1FlexGrid1.[Select](rg)
            Dim rg1 As New C1.Win.C1FlexGrid.CellRange()
            'Select nothing in Grid
            C1FlexGrid1.[Select](rg1)
        Else
            'If TextBox contains some text to be searched
            _StartSearch = True

            Dim rg As New C1.Win.C1FlexGrid.CellRange()
            C1FlexGrid1.[Select](rg)
            rg.c1 = 1
            rg.c2 = C1FlexGrid1.Cols.Count - 1
            rg.r1 = 1
            rg.r2 = C1FlexGrid1.Rows.Count - 1
            'Select all cells to search the Grid and redraw search results with Red ForeColor
            C1FlexGrid1.[Select](rg)
            'C1.Win.C1FlexGrid.CellRange rg1 = new C1.Win.C1FlexGrid.CellRange();
            'c1FlexGrid1.Select(rg1);
        End If
    End Sub

    Private Sub btn_Clear_Click(sender As Object, e As EventArgs) Handles btn_Clear.Click
        'Clear the TextBox
        tbSearchBox.Text = String.Empty
        _StartSearch = False

        Dim rg As New C1.Win.C1FlexGrid.CellRange()
        rg.c1 = 1
        rg.c2 = C1FlexGrid1.Cols.Count - 1
        rg.r1 = 1
        rg.r2 = C1FlexGrid1.Rows.Count - 1
        'Select all cells to redraw their content with default color
        C1FlexGrid1.[Select](rg)
        Dim rg1 As New C1.Win.C1FlexGrid.CellRange()
        'Select nothing in Grid
        C1FlexGrid1.[Select](rg1)
    End Sub

    Private Sub C1FlexGrid1_OwnerDrawCell(sender As Object, e As C1.Win.C1FlexGrid.OwnerDrawCellEventArgs) Handles C1FlexGrid1.OwnerDrawCell
        'Check if OwnerDrawCell used for Searching
        If _StartSearch Then
            'Getting content of cell
            Dim CellContent As String = e.Text
            'Check whether cell contains the Text in TextBox
            If CellContent.Contains(tbSearchBox.Text) Then
                Dim brush As New SolidBrush(Color.Red)
                Dim x As [Single] = 0
                'Traverse celltext and set ForeColor.
                For i As Integer = 0 To CellContent.Length - 1
                    Dim character As String = CellContent(i).ToString()
                    'Color the Text of Search Result with Red
                    e.Graphics.DrawString(character, c1FlexGrid1.Font, brush, e.Bounds.X + x, e.Bounds.Y)

                    'Next character needs to be shifted right;
                    'depending on the space occupied by the previous character as per its FontSize/FontStyle
                    x += (e.Graphics.MeasureString(character, Me.c1FlexGrid1.Font)).Width - 3

                    'To restrict FlexGrid to draw default cell content
                    e.Handled = True
                Next
            End If
        End If
        'Whether Search completed throughout all cells of grid
        If e.Row = c1FlexGrid1.Rows.Count AndAlso e.Col = c1FlexGrid1.Cols.Count Then
            _StartSearch = False
        End If
    End Sub
End Class
